/*=============================================================================
	UnXC_Lev.h
=============================================================================*/

#ifndef _INC_XC_LEV
#define _INC_XC_LEV

class XC_ENGINE_API UXC_Level : public ULevel
{
	public:
	UXC_Level()
	{};

	//UObject interface
	virtual void Destroy();

	//ULevel interface
	virtual void TickNetServer( FLOAT DeltaSeconds );
	virtual AActor* SpawnActor( UClass* Class, FName InName=NAME_None, AActor* Owner=NULL, class APawn* Instigator=NULL, FVector Location=FVector(0,0,0), FRotator Rotation=FRotator(0,0,0), AActor* Template=NULL, UBOOL bNoCollisionFail=0, UBOOL bRemoteOwned=0 );
	virtual void CleanupDestroyed( UBOOL bForce );
	virtual void SetActorCollision( UBOOL bCollision );
	virtual void WelcomePlayer( UNetConnection* Connection, TCHAR* Optional=TEXT("") );

	//FNetworkNotify interface
	virtual EAcceptConnection NotifyAcceptingConnection();
	virtual void NotifyAcceptedConnection( class UNetConnection* Connection );
	virtual void NotifyReceivedText(UNetConnection* Connection, const TCHAR* Text);

	//UXC_Level interface
	virtual INT ServerTickClients( FLOAT DeltaSeconds );

	DECLARE_CLASS(UXC_Level,ULevel,0,XC_Engine);
};

//To be used as a vtable template
class XC_ENGINE_API UXC_Model : public UModel
{
#ifndef NODECALS
//	DECLARE_CLASS(UXC_Model,UModel,0,XC_Engine)
#else
//	DECLARE_CLASS(UXC_Model,UModel,CLASS_RuntimeStatic,XC_Engine)
#endif
public:
	//Virtual method used to speedup traces
/*	UBOOL LineCheck
	(
		FCheckResult	&Result,
		AActor			*Owner,
		FVector			End,
		FVector			Start,
		FVector			Extent,
		DWORD           ExtraNodeFlags
	);*/

	//Non-virtual method for multithreaded relevancy checks
	BYTE FastRepLineCheck( FVector4* End, FVector4* Start );
};

#ifndef DISABLE_ADDONS
#include "XC_CoreObj.h"

class XC_ENGINE_API FXC_BrushTrackerFixer : public FGenericSystem
{
public:
	TArray<AMover*> StaticMovers;
	UXC_GameEngine* Game;
	ULevel* Level;
	//FExec interface
//	UBOOL Exec( const TCHAR* Cmd, FOutputDevice& Ar );

	FXC_BrushTrackerFixer()
	:	StaticMovers(0)
	,	Level(NULL)
	{};

	//FGenericSystem interface
	UBOOL Init();
	INT Tick( FLOAT DeltaSeconds=0.f);
	void Exit();

	UBOOL IsTyped( const TCHAR* Type);
};

#endif



#endif
